/*******************************************************************************
 * Copyright (c) 2024, Skeyes (on behalf of FABEC) and Nilacandi
 * All rights reserved.
 *
 * This source code is licensed under the license found in the
 * LICENSE.txt file in the root directory of this source tree.
 *******************************************************************************/
/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.36).
 * https://github.com/swagger-api/swagger-codegen Do not edit the class manually.
 */
package aero.facilis.validator.api;

import java.util.Set;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import aero.facilis.validator.exception.UserException;
import aero.facilis.validator.model.ValidationOption;
import io.swagger.annotations.Api;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.responses.ApiResponses;
import io.swagger.v3.oas.annotations.security.SecurityRequirement;

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.SpringCodegen",
    date = "2022-12-16T07:05:00.434Z[GMT]")
@Validated
@Api(tags = "Validation Options")
public interface ValidationOptionsApi {

  @Operation(summary = "Get Validation Options",
      description = "Returns the list of available schemas and business rules with identifier and display name.",
      security = {@SecurityRequirement(name = "BearerAuth")}, tags = {})
  @ApiResponses(value = {@ApiResponse(responseCode = "200",
      description = "A list of available schemas and business rules with identifier and display name.",
      content = @Content(mediaType = "application/json",
          schema = @Schema(implementation = ValidationOption.class)))})
  @RequestMapping(value = "/validation-options", produces = {"application/json"},
      method = RequestMethod.GET)
  ResponseEntity<Set<ValidationOption>> getValidationOptions() throws UserException;

  @Operation(summary = "Get Validation Options (Schemas Only)",
      description = "Returns the list of available schemas with identifier and display name.",
      security = {@SecurityRequirement(name = "BearerAuth")}, tags = {})
  @ApiResponses(value = {@ApiResponse(responseCode = "200",
      description = "A list of available schemas with identifier and display name.",
      content = @Content(mediaType = "application/json",
          schema = @Schema(implementation = ValidationOption.class)))})
  @RequestMapping(value = "/validation-options/schema/{versionCode}",
      produces = {"application/json"}, method = RequestMethod.GET)
  ResponseEntity<Set<ValidationOption>> getValidationOptionsSchema(
      @Parameter(in = ParameterIn.PATH, description = "", required = true,
          schema = @Schema()) @PathVariable("versionCode") String versionCode)
      throws UserException;

  @Operation(summary = "Get Validation Options (Business Rules Only)",
      description = "Returns the list of available business rules with identifier and display name.",
      security = {@SecurityRequirement(name = "BearerAuth")}, tags = {})
  @ApiResponses(value = {@ApiResponse(responseCode = "200",
      description = "A list of available business rules with identifier and display name.",
      content = @Content(mediaType = "application/json",
          schema = @Schema(implementation = ValidationOption.class)))})
  @RequestMapping(value = "/validation-options/bizrule/{versionCode}",
      produces = {"application/json"}, method = RequestMethod.GET)
  ResponseEntity<Set<ValidationOption>> getValidationOptionsBizRule(
      @Parameter(in = ParameterIn.PATH, description = "", required = true,
          schema = @Schema()) @PathVariable("versionCode") String versionCode)
      throws UserException;

}

